Index: trunk/tools/documentation/plotting/bar_time.html
===================================================================
--- trunk/tools/documentation/plotting/bar_time.html	(revision 1543)
+++ trunk/tools/documentation/plotting/bar_time.html	(revision 1543)
@@ -0,0 +1,82 @@
+<HTML>
+  <HEAD>
+    <META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=utf-8"/>
+    <LINK REL="stylesheet" TYPE="text/css" HREF="../PyNCplot.css"/>
+  </HEAD>
+
+  </HEAD>
+  <BODY>
+    <DIV CLASS="valheader">
+      bar char plot time
+    </DIV>
+    <DIV CLASS="valimg">
+      Function to plot a bar char figure with multiple sources and time axis
+      <IMG WIDTH="100%" SRC="figs/bar_time_rain_CRU-NCEP_DJFmean_norm.png"></IMG>
+    </DIV>
+    <DIV CLASS="valhelp">
+    draw_bar_time(ncfile, values)<BR>
+    &nbsp;&nbsp;ncfile = ':' list of [filen];[dimslice];[tvarn];[yvarn]<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[filen]: name of the file<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[dimslice]: '|' list of [dimn],[dimrange]<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[dimn]: name of the dimension<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[dimrange]: range for the slice<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* [integer]: which value of the dimension<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* -1: all along the dimension<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* -9: last value of the dimension<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* [beg]@[end]@[inc] slice from [beg] to [end] every [inc]<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;* NOTE, no dim name all the dimension size<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[tvarn]: name of the variable time<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[yvarn]: name of the variable to use for the values<BR>
+    &nbsp;&nbsp;values = [dimxyfmt];[yaxislab];[yunits];[aval];[rangevals];[timevals];<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[labels];[colors];[wdth];[graphtit];[legvalues];[kindfig];[fign];[close]<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[dimxyfmt]=[dxs],[dxf],[Ndx],[ordx],[dys],[dyf],[Ndy],[ordy]: format of the values at each <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;axis (or single 'auto' for 'auto','auto')<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[dxs]: style of x-axis ('auto' for 'pretty')<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'Nfix', values computed at even 'Ndx'<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'Stringlist', a given list of strings<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'Vfix', values computed at even 'Ndx' increments<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'pretty', values computed following aprox. 'Ndx' at 'pretty' intervals (2.,2.5,4,5,10)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[dxf]: format of the labels at the x-axis<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[Ndx]: Number of ticks at the x-axis (for 'Stringlist', '@' list of labels)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[ordx]: angle of orientation of ticks at the x-axis ('auto' for horizontal)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[dys]: style of y-axis ('auto' for 'pretty')<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[dyf]: format of the labels at the y-axis<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[Ndy]: Number of ticks at the y-axis<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[ordy]: angle of orientation of ticks at the y-axis ('auto' for horizontal)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[yaxislab]: Label for the y-axis ('!' for spaces)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[yunits]: units of the y-label<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[aval]: which acis should be used for the values ('x' or 'y')<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[rangevals]: Range of the axis with the values (singel 'None' for 'auto','auto')<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[vmin],[vmax]: minimum and maximum values<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'auto': the computed minimumm or maximum of the values  <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[timevals]: [timen]|[units]|[kind]|[tfmt] time labels characteristics<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[timen]; name of the time variable<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[units]; units string according to CF conventions ([tunits] since <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[YYYY]-[MM]-[DD] [[HH]:[MI]:[SS]], '!' for spaces)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[kind]; kind of output<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'Nval': according to a given number of values as 'Nval',[Nval]<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'exct': according to an exact time unit as 'exct',[tunit]; <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tunit= [Nunits],[tu]; [tu]= 'c': centuries, 'y': year, 'm': month,<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'w': week, 'd': day, 'h': hour, 'i': minute, 's': second, <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'l': milisecond<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[tfmt]; desired format<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[labels]: ',' list of labels for the legend ('None' for no-labels)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[colors]: ',' list of colors (single value same color, 'auto' automati<BR>c)
+    &nbsp;&nbsp;&nbsp;&nbsp;[wdth]: width of the bars<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[graphtit]: title of the figure '!' for spaces<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[legvalues]=[locleg]|[fontsize]: <BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[locleg]: location of the legend (0, autmoatic)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1: 'upper right', 2: 'upper left', 3: 'lower left', 4: 'lower right',<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5: 'right', 6: 'center left', 7: 'center right', 8: 'lower center',<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9: 'upper center', 10: 'center'<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[fontsize]: font size for the legend (auto for 12)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[kindfig]: kind of output figure (png, pdf, ps)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[fign]: name of the figure (without extension)<BR>
+    &nbsp;&nbsp;&nbsp;&nbsp;[close]: whether figure should be close or not<BR>
+    </DIV>
+    <DIV CLASS="valins">
+      $ python ${pyHOME}/drawing.py -o draw_bar_time -f 'Forcing_rainstats_OKstomate_CRUNCEP_spinup_SESA_DJFmean_norm_meanstd_stat2.nc;time_centered,-1;time_centered;rainnorm:Forcing_rainstats_OKstomate_CRUNCEP_spinup_SACZ_DJFmean_norm_meanstd_stat2.nc;time_centered,-1;time_centered;rainnorm' -S 'auto;pr;1;y;None;year|seconds!since!1958-01-01!00:00:00|exct,5,y|%Y;SESA,SACZ;#AA0000,#0000AA;10000000.;normalized!evolution!of!$precipitaion_{DJFmean}$!with!CRU-NCEP!forcing;0|10;png;bar_time_rain_CRU-NCEP_DJFmean_norm;yes'
+    </DIV>
+  </BODY>
+</HTML>
+